//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxVdrTools
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   15.11.2003
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-05-19 20:42:12 +0200 (Fr, 19 Mai 2006) $
 *   $Revision: 1.2 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxVDRTools_H__
#define __AxVDRTools_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
#include <string>

//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/osdbase.h>

//----- local -----------------------------------------------------------------

//----- other includes --------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================
class cDevice;
class cChannel;

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace VDR
  //===========================================================================
  namespace VDR
  {

    //=============================================================================
    //     class Tools
    //=============================================================================
    /** The class Tools contains some small helper functions for
     *  vdr-plugins.
     */
    class Tools
    {
      public:
        //-------------------------------------------------------------------------
        //     getOSStateStr()
        //-------------------------------------------------------------------------
        static const char *getOSStateStr(eOSState);

        //-------------------------------------------------------------------------
        //     getKeyStr()
        //-------------------------------------------------------------------------
        static std::string getKeyStr(eKeys);

        //-------------------------------------------------------------------------
        //     dumpDevices()
        //-------------------------------------------------------------------------
        static void dumpDevices();

        //-------------------------------------------------------------------------
        //     dumpDevice()
        //-------------------------------------------------------------------------
        static void dumpDevice(const cDevice *theDevice);

        //-------------------------------------------------------------------------
        //     dumpChannels()
        //-------------------------------------------------------------------------
        static void dumpChannels();

        //-------------------------------------------------------------------------
        //     dumpChannel()
        //-------------------------------------------------------------------------
        static void dumpChannel(const cChannel *theChannel);

    }; // class Tools

  }; // namespace VDR

}; // namespace Ax

#endif

