//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxMailInternal
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   15.11.2003
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-04-16 14:27:56 +0200 (So, 16 Apr 2006) $
 *   $Revision: 202 $
 */
//-----------------------------------------------------------------------------
#ifndef __Ax_Mail_Internal_H__
#define __Ax_Mail_Internal_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
#include <string>

//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
//----- local -----------------------------------------------------------------
#include "c-client-header.h"

//----- other includes --------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================
class cDevice;
class cChannel;

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace Mail
  //===========================================================================
  namespace Mail
  {
    //=============================================================================
    //     namespace Internal
    //=============================================================================
    namespace Internal
    {
      //-----------------------------------------------------------------------
      //     dumpStream()
      //-----------------------------------------------------------------------
      void dumpStream(const MAILSTREAM *s);

      //-----------------------------------------------------------------------
      //     dumpMsgCache()
      //-----------------------------------------------------------------------
      void dumpMsgCache(const MESSAGECACHE *s);

      //-----------------------------------------------------------------------
      //     dumpMsgBody()
      //-----------------------------------------------------------------------
      void dumpMsgBody(const BODY *s);

      //-----------------------------------------------------------------------
      //     dumpEnvelope()
      //-----------------------------------------------------------------------
      void dumpEnvelope(const ENVELOPE *s);

    }; // namespace Internal

  }; // namespace Mail

}; // namespace Ax

#endif

