//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class Ax::Mail::LogHandlerCBP
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: Alex
 * Date:   06.01.2006
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-04-17 11:29:52 +0200 (Mo, 17 Apr 2006) $
 *   $Revision: 203 $
 */
//-----------------------------------------------------------------------------
#ifndef __Ax_Mail_LogHandlerCBP_H__
#define __Ax_Mail_LogHandlerCBP_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- ICE -------------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Mail/LogHandler.h>

//----- local -----------------------------------------------------------------
#include "CallBackProcessor.h"

//----- vdr -------------------------------------------------------------------
//----- c-client --------------------------------------------------------------
//----- other includes --------------------------------------------------------

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace Mail
  //===========================================================================
  namespace Mail
  {
    //=============================================================================
    //     class LogHandlerCBP
    //=============================================================================
    class LogHandlerCBP : public CallBackProcessor
    {
        //-------------------------------------------------------------------------
        //     typedefs
        //-------------------------------------------------------------------------
        typedef CallBackProcessor PARENT;

      public:
        //-------------------------------------------------------------------------
        //     LogHandlerCBP()
        //-------------------------------------------------------------------------
        LogHandlerCBP( LogHandler        &theLogHandler
                     , MailBox           *theMailBox
                     , const std::string &theName
                     , CallBackProcessor *theParent
                     );

        //-------------------------------------------------------------------------
        //     ~LogHandlerCBP()
        //-------------------------------------------------------------------------
        virtual ~LogHandlerCBP();

        //---------------------------------------------------------------------
        //     log()
        //---------------------------------------------------------------------
        virtual bool log(LogLevel theLevel, const std::string &theMsg);

        //=========================================================================
        //     process c-client callbacks
        //=========================================================================
        virtual bool process_mm_notify    (const std::string &theMsg, long theErrorFlag);
        virtual bool process_mm_log       (const std::string &theMsg, long theErrorFlag);
        virtual bool process_mm_dlog      (const std::string &theMsg);
        virtual bool process_mm_fatal     (const std::string &theMsg);

      private:
        //-------------------------------------------------------------------------
        //     attributes
        //-------------------------------------------------------------------------
        LogHandler &myLogHandler;

    }; // class LogHandlerCBP

  }; // namespace Mail

}; // namespace Ax

#endif

