//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class Ax::Mail::MailBoxCBP
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: Alex
 * Date:   27.12.2004
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-04-17 11:29:52 +0200 (Mo, 17 Apr 2006) $
 *   $Revision: 203 $
 */
//-----------------------------------------------------------------------------
#ifndef __Ax_Mail_MailBoxCBP_H__
#define __Ax_Mail_MailBoxCBP_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- ICE -------------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
#include <string>

//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Mail/Globals.h>
#include <Ax/Mail/LogHandler.h>

//----- vdr -------------------------------------------------------------------
//----- c-client --------------------------------------------------------------
//----- other includes --------------------------------------------------------
//----- local -----------------------------------------------------------------
#include "LogHandlerCBP.h"

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace Mail
  //===========================================================================
  namespace Mail
  {
    //-------------------------------------------------------------------------
    //     forward declarations
    //-------------------------------------------------------------------------
    class MailBox;

    //=============================================================================
    //     class MailBoxCBP
    //=============================================================================
    class MailBoxCBP : public LogHandlerCBP
    {
        //-------------------------------------------------------------------------
        //     typedefs
        //-------------------------------------------------------------------------
        typedef LogHandlerCBP PARENT;

      public:
        //-------------------------------------------------------------------------
        //     MailBoxCBP()
        //-------------------------------------------------------------------------
        MailBoxCBP( LogHandler        &theLogHandler
                  , MailBox           *theMailBox
                  , const std::string &theName
                  , CallBackProcessor *theParent
                  );

        //-------------------------------------------------------------------------
        //     ~MailBoxCBP()
        //-------------------------------------------------------------------------
        virtual ~MailBoxCBP();

      public:
        //-------------------------------------------------------------------------
        //     process_mm_login()
        //-------------------------------------------------------------------------
        virtual bool process_mm_login(NETMBX *theMailBox, char *theUser, char *thePassword, long theTrials);

    }; // class MailBoxCBP

  }; // namespace Mail

}; // namespace Ax

#endif

