//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class Ax::Mail::Mail
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   16.04.2006
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-04-16 14:27:56 +0200 (So, 16 Apr 2006) $
 *   $Revision: 202 $
 */
//-----------------------------------------------------------------------------
#ifndef __Ax_Mail_MsgBody_H__
#define __Ax_Mail_MsgBody_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- ICE -------------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
//----- local -----------------------------------------------------------------
#include "c-client-header.h"

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace Mail
  //===========================================================================
  namespace Mail
  {
    //=============================================================================
    //     forward declarations
    //=============================================================================

    //=============================================================================
    //     class MsgBody
    //=============================================================================
    /** simply a wrapper for c-client's BODY-Pointer
     *
     *  No memory-management is done here, this class is simply to hide
     *  the c-client BODY-type in the implementation of Ax::Mail and not
     *  to have c-client types in the headers of Ax::Mail.
     */
    class MsgBody
    {
      public:
        //-------------------------------------------------------------------------
        //     MsgBody()
        //-------------------------------------------------------------------------
        MsgBody(BODY *theBody);

        //-------------------------------------------------------------------------
        //     ~MsgBody()
        //-------------------------------------------------------------------------
        ~MsgBody();

        //-------------------------------------------------------------------------
        //     MsgBody()
        //-------------------------------------------------------------------------
        /** copy constructor
         */
        MsgBody(const MsgBody &that);

        //-------------------------------------------------------------------------
        //     operator=()
        //-------------------------------------------------------------------------
        /** assignment operator
         */
        MsgBody &operator=(const MsgBody &that);

        //-------------------------------------------------------------------------
        //     isNull()
        //-------------------------------------------------------------------------
        bool isNull() const { return myMsgBody == 0; }

        //-------------------------------------------------------------------------
        //     operator *()
        //-------------------------------------------------------------------------
        /** Returns a pointer to the internal elt/MESSAGECACHE
         */
        BODY *operator *() const { return myMsgBody; }

        //-------------------------------------------------------------------------
        //     operator ->()
        //-------------------------------------------------------------------------
        /** Returns a pointer to the internal elt/MESSAGECACHE
         *
         * allows direct access to members of myMsgBody
         */
        BODY *operator ->() const { return myMsgBody; }

        //-----------------------------------------------------------------------
        //     dump()
        //-----------------------------------------------------------------------
        /** Dump internal information to syslog
         */
        void dump() const;

      private:
        //-------------------------------------------------------------------------
        //     attributes
        //-------------------------------------------------------------------------
        BODY *myMsgBody;

    }; // class MsgBody

  }; // namespace Mail

}; // namespace Ax

#endif

