//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxMenuMailListView
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   15.11.2003
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-04-29 11:02:09 +0200 (Sa, 29 Apr 2006) $
 *   $Revision: 1.14 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxMenuMailListView_H__
#define __AxMenuMailListView_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Mail/Globals.h>

//----- local -----------------------------------------------------------------
#include "AxMenuMailViewBase.h"

//----- other includes --------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================
class AxPluginMailBox;

//=============================================================================
//     class AxMenuMailListView
//=============================================================================
/** Menu to display a list of mails.
 */
class AxMenuMailListView : public AxMenuMailViewBase
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef AxMenuMailViewBase PARENT;
    typedef AxMenuMailListView MYSELF;

  protected:
    //-------------------------------------------------------------------------
    //     enums
    //-------------------------------------------------------------------------
    enum AxEAction
    {
      A_FIRST          = PARENT::A_LAST
    , A_OPEN_CURRENT   = A_FIRST
    , A_UPDATE_CURRENT
    , A_SHOW_PAGE_JUMP
    , A_SHOW_PAGE_MARK
    , A_LAST
    };

    //-------------------------------------------------------------------------
    //     enum AxPage
    //-------------------------------------------------------------------------
    enum AxPage
    {
      PAGE_JUMP
    , PAGE_MARK
    }; // enum AxPage

  public:
    //-------------------------------------------------------------------------
    //     AxMenuMailListView()
    //-------------------------------------------------------------------------
    /** Constructor
     */
    AxMenuMailListView( AxPluginMailBox      *thePlugin
                      , Ax::Mail::MailFolder *theFolder
                      , bool                  theIsMainMenuAction
                      );

    //-------------------------------------------------------------------------
    //     ~AxMenuMailListView()
    //-------------------------------------------------------------------------
    /** Destructor
     */
    virtual ~AxMenuMailListView();

    //-------------------------------------------------------------------------
    //     processAction()
    //-------------------------------------------------------------------------
    virtual eOSState processAction(const Ax::VDR::Action &theAction, eOSState = osUnknown);

    //-------------------------------------------------------------------------
    //     setCurrentMail()
    //-------------------------------------------------------------------------
    virtual void setCurrentMail(Ax::Mail::Mail *theMail);

    //-------------------------------------------------------------------------
    //     updateActions()
    //-------------------------------------------------------------------------
    virtual void updateActions();

  protected:
    //-------------------------------------------------------------------------
    //     updateWithCurrentMail()
    //-------------------------------------------------------------------------
    virtual void updateWithCurrentMail();

    //-------------------------------------------------------------------------
    //     informSubOSDClosed()
    //-------------------------------------------------------------------------
    virtual void informSubOSDClosed(const Ax::VDR::Action &theAction, eKeys theKey);

    //-------------------------------------------------------------------------
    //     informCurrentChanged()
    //-------------------------------------------------------------------------
    virtual void informCurrentChanged(int theOldCurrent);

  private:
    //-------------------------------------------------------------------------
    //     updateTitle()
    //-------------------------------------------------------------------------
    void updateTitle();

    //-------------------------------------------------------------------------
    //     showMails()
    //-------------------------------------------------------------------------
    void showMails();

    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    bool myIsMainMenuAction;

}; // class AxMenuMailListView

#endif

